'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var streamBase = require('@tanker/stream-base');
var _Object$defineProperty = _interopDefault(require('@babel/runtime-corejs2/core-js/object/define-property'));
var _Object$defineProperties = _interopDefault(require('@babel/runtime-corejs2/core-js/object/define-properties'));
var _Object$getOwnPropertyDescriptors = _interopDefault(require('@babel/runtime-corejs2/core-js/object/get-own-property-descriptors'));
var _Object$getOwnPropertyDescriptor = _interopDefault(require('@babel/runtime-corejs2/core-js/object/get-own-property-descriptor'));
var _Object$getOwnPropertySymbols = _interopDefault(require('@babel/runtime-corejs2/core-js/object/get-own-property-symbols'));
var _Object$keys = _interopDefault(require('@babel/runtime-corejs2/core-js/object/keys'));
var _defineProperty = _interopDefault(require('@babel/runtime-corejs2/helpers/defineProperty'));
var _objectWithoutProperties = _interopDefault(require('@babel/runtime-corejs2/helpers/objectWithoutProperties'));
var _classCallCheck = _interopDefault(require('@babel/runtime-corejs2/helpers/classCallCheck'));
var _possibleConstructorReturn = _interopDefault(require('@babel/runtime-corejs2/helpers/possibleConstructorReturn'));
var _getPrototypeOf = _interopDefault(require('@babel/runtime-corejs2/helpers/getPrototypeOf'));
var _inherits = _interopDefault(require('@babel/runtime-corejs2/helpers/inherits'));
var _Date$now = _interopDefault(require('@babel/runtime-corejs2/core-js/date/now'));
var errors = require('@tanker/errors');
var FilePonyfill = _interopDefault(require('@tanker/file-ponyfill'));
var _regeneratorRuntime = _interopDefault(require('@babel/runtime-corejs2/regenerator'));
var _asyncToGenerator = _interopDefault(require('@babel/runtime-corejs2/helpers/asyncToGenerator'));
var _typeof = _interopDefault(require('@babel/runtime-corejs2/helpers/typeof'));
var _assertThisInitialized = _interopDefault(require('@babel/runtime-corejs2/helpers/assertThisInitialized'));
var FileReader = _interopDefault(require('@tanker/file-reader'));

function ownKeys(object, enumerableOnly) { var keys = _Object$keys(object); if (_Object$getOwnPropertySymbols) { var symbols = _Object$getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return _Object$getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (_Object$getOwnPropertyDescriptors) { _Object$defineProperties(target, _Object$getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { _Object$defineProperty(target, key, _Object$getOwnPropertyDescriptor(source, key)); }); } } return target; }
var defaultMime = 'application/octet-stream';
var getConstructorName = function getConstructorName(constructor) {
  if (constructor === ArrayBuffer) return 'ArrayBuffer';else if (constructor === Uint8Array) return 'Uint8Array';else if (constructor === File || constructor === FilePonyfill) // must be before Blob
    return 'File'; // else if (constructor === Blob)

  return 'Blob';
};
var converters = {
  ArrayBuffer: function ArrayBuffer(uint8array) {
    return uint8array.buffer.byteLength === uint8array.length ? uint8array.buffer : new Uint8Array(uint8array).buffer;
  },
  Uint8Array: function (_Uint8Array) {
    function Uint8Array(_x) {
      return _Uint8Array.apply(this, arguments);
    }

    Uint8Array.toString = function () {
      return _Uint8Array.toString();
    };

    return Uint8Array;
  }(function (uint8array) {
    return uint8array;
  }),
  Blob: function (_Blob) {
    function Blob(_x2, _x3) {
      return _Blob.apply(this, arguments);
    }

    Blob.toString = function () {
      return _Blob.toString();
    };

    return Blob;
  }(function (uint8array, _ref) {
    var mime = _ref.mime;
    return new Blob([uint8array], {
      type: mime || defaultMime
    });
  }),
  File: function File(uint8array, _ref2) {
    var mime = _ref2.mime,
        name = _ref2.name,
        lastModified = _ref2.lastModified;
    return new FilePonyfill([uint8array], name || '', {
      type: mime || defaultMime,
      lastModified: lastModified || _Date$now()
    });
  }
};

var MergerStream =
/*#__PURE__*/
function (_BaseMergerStream) {
  _inherits(MergerStream, _BaseMergerStream);

  // <T: A | B> is interpreted as 'T must be A or B at all times', not 'T cannot exist unless it is either A or B and should just not change after instantiation'
  // $FlowIssue https://github.com/facebook/flow/issues/7449
  function MergerStream() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref3$type = _ref3.type,
        type = _ref3$type === void 0 ? Uint8Array : _ref3$type,
        mime = _ref3.mime,
        name = _ref3.name,
        otherOptions = _objectWithoutProperties(_ref3, ["type", "mime", "name"]);

    _classCallCheck(this, MergerStream);

    if (![ArrayBuffer, Blob, File, FilePonyfill, Uint8Array].some(function (klass) {
      return type === klass;
    })) throw new errors.InvalidArgument('options.type', 'class in [ArrayBuffer, Blob, File, FilePonyfill, Uint8Array]', type);
    if (mime && typeof mime !== 'string') throw new errors.InvalidArgument('options.mime', 'string', mime);
    if (name && typeof name !== 'string') throw new errors.InvalidArgument('options.name', 'string', name);
    return _possibleConstructorReturn(this, _getPrototypeOf(MergerStream).call(this, _objectSpread({}, otherOptions, {
      type: type,
      mime: mime,
      name: name,
      converter: converters[getConstructorName(type)]
    })));
  }

  return MergerStream;
}(streamBase.BaseMergerStream);

var SlicerStream =
/*#__PURE__*/
function (_Readable) {
  _inherits(SlicerStream, _Readable);

  function SlicerStream(options) {
    var _this;

    _classCallCheck(this, SlicerStream);

    if (!options || _typeof(options) !== 'object' || options instanceof Array) throw new errors.InvalidArgument('options', 'object', options);
    var _source = options.source,
        outputSize = options.outputSize;
    if ([ArrayBuffer, Uint8Array, Blob, File].every(function (constructor) {
      return !(_source instanceof constructor);
    })) throw new errors.InvalidArgument('options.source', 'either an ArrayBuffer, a Uint8Array, a Blob, or a File', _source);
    if (outputSize && typeof outputSize !== 'number') throw new errors.InvalidArgument('options.outputSize', 'number', outputSize);
    _this = _possibleConstructorReturn(this, _getPrototypeOf(SlicerStream).call(this, {
      // buffering a single output chunk
      objectMode: true,
      highWaterMark: 1
    }));

    _defineProperty(_assertThisInitialized(_this), "_mode", void 0);

    _defineProperty(_assertThisInitialized(_this), "_source", void 0);

    _defineProperty(_assertThisInitialized(_this), "_outputSize", void 0);

    _defineProperty(_assertThisInitialized(_this), "_readingState", void 0);

    _defineProperty(_assertThisInitialized(_this), "_fileReader", void 0);

    _defineProperty(_assertThisInitialized(_this), "_read", function ()
    /* size: number */
    {
      if (_this._mode === 'binary') {
        _this._readBinary();
      } else {
        _this._readFile();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_initBinaryMode", function (source) {
      _this._mode = 'binary';
      _this._source = source instanceof ArrayBuffer ? new Uint8Array(source) : source;
      _this._readingState = {
        byteSize: _this._source.length,
        byteIndex: 0
      };
    });

    _defineProperty(_assertThisInitialized(_this), "_readBinary", function () {
      var _this$_readingState = _this._readingState,
          byteSize = _this$_readingState.byteSize,
          startIndex = _this$_readingState.byteIndex;
      var endIndex = Math.min(startIndex + _this._outputSize, byteSize); // $FlowIKnow we know _source is an Uint8Array

      var bytes = _this._source.subarray(startIndex, endIndex);

      var pushMore = _this.push(bytes);

      if (endIndex >= byteSize) {
        _this.push(null);

        return;
      }

      _this._readingState.byteIndex = endIndex;

      if (pushMore) {
        _this._readBinary();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_initFileMode", function (source) {
      _this._mode = 'file';
      _this._source = source;
      _this._fileReader = new FileReader(source);
    });

    _defineProperty(_assertThisInitialized(_this), "_readFile",
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    _regeneratorRuntime.mark(function _callee() {
      var buffer, length;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return _this._fileReader.readAsArrayBuffer(_this._outputSize);

            case 3:
              buffer = _context.sent;
              length = buffer.byteLength;

              if (!(length === 0)) {
                _context.next = 8;
                break;
              }

              _this.push(null);

              return _context.abrupt("return");

            case 8:
              _this.push(new Uint8Array(buffer));

              if (length < _this._outputSize) {
                _this.push(null);
              }

              _context.next = 15;
              break;

            case 12:
              _context.prev = 12;
              _context.t0 = _context["catch"](0);

              _this.emit('error', _context.t0);

            case 15:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 12]]);
    })));

    _this._outputSize = outputSize || 5 * 1024 * 1024; // 5MB

    if (_source instanceof ArrayBuffer || _source instanceof Uint8Array) {
      _this._initBinaryMode(_source);
    } else {
      _this._initFileMode(_source);
    }

    return _this;
  }

  return SlicerStream;
}(streamBase.Readable);

Object.defineProperty(exports, 'Duplex', {
  enumerable: true,
  get: function () {
    return streamBase.Duplex;
  }
});
Object.defineProperty(exports, 'Readable', {
  enumerable: true,
  get: function () {
    return streamBase.Readable;
  }
});
Object.defineProperty(exports, 'ResizerStream', {
  enumerable: true,
  get: function () {
    return streamBase.ResizerStream;
  }
});
Object.defineProperty(exports, 'Transform', {
  enumerable: true,
  get: function () {
    return streamBase.Transform;
  }
});
Object.defineProperty(exports, 'Uint8Buffer', {
  enumerable: true,
  get: function () {
    return streamBase.Uint8Buffer;
  }
});
Object.defineProperty(exports, 'Writable', {
  enumerable: true,
  get: function () {
    return streamBase.Writable;
  }
});
exports.MergerStream = MergerStream;
exports.SlicerStream = SlicerStream;
